		.include	16f84.h		; ł͂PUeWSI
		.osc		hs		; IV[^HS
		.wdt		off		; EHb`hbOnee
		.pwrt		on		; p[Abv^C}nm
		.protect	off		; veNgnee

;{\[X http://d4.princess.ne.jp/ ŔzzĂ܂B
;{\[X̉ǌ́Ahttp://gnunilink.sourceforge.net/ ŔzzĂ܂B

; Speed (or closet)
;#define		SPEED_20MHZ

;	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC


;******************************************************************************
; Timing Calibration Values - These are non critical in that they don't have 
; to be absolutely correct, but it's nicer to be almost right if you can....

; 100us delay loop is 8 + (n * 7) cycles.

;//SPEED_4MHZ
;#define		delay100us	13
;#define		baud_val	12	; 19231 baud

;//SPEED_8MHZ
;#define		delay100us	27
;#define		baud_val	25	; 19231 baud

;//SPEED_10MHZ
;#define		delay100us	34
;#define		baud_val	32	; 18939 baud

;//SPEED_16MHZ
;#define		delay100us	56
;#define		baud_val	51	; 19231 baud

;//SPEED_20MHZ
delay50us	equ	8	; 8*32cyc*0.2us=51.2us
delay100us	equ	70
baud_val	equ	64	; 19231 baud


;******************************************************************************
; Port definitions, which signal is where on the porta
DataBit		equ	0
ClockBit	equ	4		;vV~bggK
BusOnBit	equ	2
DebugBit	equ	3
;******************************************************************************
;                               Setup Register Locations

		org	0ch
DataVal		ds	1
Count		ds	1
Count2		ds	1
Count3		ds	1	;MoCg̃NbNmFp
Count4		ds	1	;MoCg̃NbNmFp
Checksum	ds	1

Rad		ds	1
Tad		ds	1
Cmd1		ds	1
Cmd2		ds	1
Parity1		ds	1
Data11		ds	1
Data12		ds	1
Data13		ds	1
Data14		ds	1
Data21		ds	1
Data22		ds	1
Data23		ds	1
Data24		ds	1
Data25		ds	1
Parity2		ds	1
EndByte		ds	1

MyId		ds	1
Display		ds	1
MyBit		ds	1
MyGroup		ds	1

Time0		ds	1
Time1		ds	1
DiskNum		ds	1
TrackNum	ds	1
DispCtrl	ds	1
SlaveBreakFlag	ds	1
porta_tmp	ds	1

clock_timer1	ds	1
clock_timer2	ds	1
data_timer1	ds	1
data_timer2	ds	1
data_timer3	ds	1

anadig		ds	1

TRISA                        equ     85h
TRISB                        equ     86h


;******************************************************************************
; Default definations for responses, these may need to be changed for you
; particular HEADUNIT

Anyone_0	equ		08Ch
Anyone_1	equ		010h
Anyone_2	equ		0FFh
Anyone_3	equ		0FFh
Anyone_4	equ		0FFh
Anyone_5	equ		0FFh

Appoint_0	equ		08Ch
Appoint_1	equ		010h
Appoint_2	equ		005h
Appoint_3	equ		0A8h
Appoint_4	equ		000h
Appoint_5	equ		000h

;******************************************************************************
; Default definations for names etc.

Track0		equ		'a'		; Track Name
Track1		equ		'n'
Track2		equ		'a'
Track3		equ		'l'
Track4		equ		'o'
Track5		equ		'g'
Track6		equ		' '
Track7		equ		' '
Track8		equ		' '
Track9		equ		' '
TrackA		equ		' '
TrackB		equ		' '
TrackC		equ		' '
TrackD		equ		' '
TrackE		equ		' '
TrackF		equ		' '

Trackd_0	equ		'D'		; Track Name
Trackd_1	equ		'I'
Trackd_2	equ		'G'
Trackd_3	equ		'I'
Trackd_4	equ		'T'
Trackd_5	equ		'A'
Trackd_6	equ		'L'
Trackd_7	equ		' '
Trackd_8	equ		' '
Trackd_9	equ		' '
Trackd_A	equ		' '
Trackd_B	equ		' '
Trackd_C	equ		' '
Trackd_D	equ		' '
Trackd_E	equ		' '
Trackd_F	equ		' '


Disk0		equ		'<'		; Disk Name
Disk1		equ		'A'
Disk2		equ		'U'
Disk3		equ		'X'
Disk4		equ		'-'
Disk5		equ		'I'
Disk6		equ		'N'
Disk7		equ		'>'
Disk8		equ		' '
Disk9		equ		' '
DiskA		equ		' '
DiskB		equ		' '
DiskC		equ		' '
DiskD		equ		' '
DiskE		equ		' '
DiskF		equ		' '

;******************************************************************************
; Start of code space

	ORG     0
	
	goto	SystemSetup
	goto	SystemSetup
;******************************************************************************





IssueSlaveBreak:
	movlw	1
	movwf	SlaveBreakFlag
	return

IssueSlaveBreak2:
	clrf	SlaveBreakFlag


	movlw	60				; 6ms (60 * 100us)
	movwf	Count

BreakLoop1:
	movlw	delay100us			; 100us 
	movwf	Count2

BreakLoop2:
	btfsc	porta, DataBit			; Data low ('Master phase')
	goto	IssueSlaveBreak2		; Databit0Ȃskip

	goto	BreakLoop3			; NOP
BreakLoop3:

	decfsz	Count2, 1			; Reduce Count2
	goto	BreakLoop2

	decfsz	Count, 1			; Reduce count 
	goto	BreakLoop1

BreakLoop4:
	movlw	40				; rely on timing. 	NASTY_HACK(RTL)Ȃ40 m[}Ȃ20
	movwf	Count

BreakLoop5:
	movlw	delay100us
	movwf	Count2

BreakLoop6:
;	IFNDEF	NASTY_HACK
;	btfss	porta, DataBit		; Data high for 2ms 
;	goto	BreakLoop4			; (moving into 'Slave Phase')
;	ENDIF

	goto	BreakLoop7			; NOP
BreakLoop7:

	decfsz	Count2, 1			; Reduce Count2
	goto	BreakLoop6

	decfsz	Count, 1			; Reduce count 
	goto	BreakLoop5

BreakStart:
	bsf	rp0			; Enable data pin as output
	bcf	TRISA, DataBit
	bcf	rp0

	clrf	SlaveBreakFlag

	bcf	porta, DataBit		; Force Data low.... 4ms

	movlw	40
	movwf	Count

BreakLoop9:
	movlw	delay100us
	movwf	Count2

BreakLoop10:
	goto	BreakLoop11			; 2 * NOP
BreakLoop11:
	goto	BreakLoop12			; 2 * NOP
BreakLoop12:

	decfsz	Count2, 1
	goto	BreakLoop10

	decfsz	Count, 1
	goto	BreakLoop9

	bsf	rp0			; Tristate data pin
	bsf	TRISA, DataBit
	bcf	rp0

	return

;******************************************************************************
; Receive a byte - received byte is placed in W register.

; Input is sampled between 1 cycle before and 3 cycles after Clock rising edge,
; depending on the asynchronous alignment with the Master

ReadByte:
	clrf	DataVal

	movlw	08
	movwf	Count

	bcf	c			; Ensure carry bit is 0

ReadLoop1:
	rlf	DataVal, 1
	clrf	Count3
	movlw	0f8h
	movwf	Count4

ReadLoop2:
	incf	Count3
	btfsc	z
	incf	Count4
	btfsc	z
	goto	ReadByte3		;MG[


	btfss	porta, ClockBit		; Wait for clock going high
	goto	ReadLoop2		; clock=Lgoto

ReadLoop3:
	clrf	Count3
ReadLoop3_2:
	incf	Count3
	btfsc	z
	goto	ReadByte3		;MG[

	btfsc	porta, ClockBit		; Wait for clock going low
	goto	ReadLoop3_2		; clock=Hgoto

	btfss	porta, DataBit		; (inverted) input
	bsf	DataVal, 0
	
	decfsz	Count, 1		; Do next bit, if any left...
	goto	ReadLoop1

	movf	DataVal, 0
	return


ReadByte2:
	clrf	DataVal
	movlw	08
	movwf	Count
	goto	ReadLoop3

ReadByte3:
;	bsf	porta, DebugBit		;;debug
;	bcf	porta, DebugBit		;;debug

	goto	ReceiveBreak
;******************************************************************************
; Send a byte - byte to ouput is in W register.

; This is the piece of code which is the most time critcal.
; Worst case the outpit bit is set a maximum of 7 cycles after Clock goes High
; and held until the Clock goes high again

; this hopefully gives enough time for the master to register it.... a LOT 
; dodgy on slow systems.

; We may have to reverse the logic on this so that the output is set before the 
; Clock goes high and changed after the Clock goes low. This will improve the i
; set up, but reduce the hold time.

SendByte:
	movwf	DataVal				; Store byte to output

	bcf	porta, DataBit

	addwf	Checksum, 1			; Compute Checksum

	movlw	08
	movwf	Count

SendLoop1:

SendLoop2:
	btfss	porta, ClockBit		; Wait for clock going high
	goto	SendLoop2

	bsf	rp0			; Enable data pin
	btfsc	DataVal, 7		; DataVal[7]=NZȂdata=LƂߏoL̂TRIS=0
	bcf	TRISA, DataBit
	
	btfss	DataVal, 7		; DataVal[7]=ZȂdata=HƂߏoẐTRIS=1
	bsf	TRISA, DataBit
	bcf	rp0

	rlf	DataVal, 1

SendLoop3:
	btfsc	porta, ClockBit		; Wait for clock going low
	goto	SendLoop3		; clock=highgoto

	decfsz	Count, 1			; Do next bit, if any left...
	goto	SendLoop1

	goto	SendLoop4			; just a little data hold
SendLoop4:

	return

;******************************************************************************
; Bit frig - works out which bit to set in the response to Master Poll

; W register is input of which stage you are on (0x00, 0x20, 0x30, 0x40 etc)
; and is returned with the byte to write (0x00 if wrong stage).

Bit_Frig:
	xorwf	MyBit, 0			; W=W xor MyBit
	andlw	0e0h				; W=W and e0h    :Strip off low bits

	btfsc	z			; Do we have a hit?
	goto	Bit_Frig_Hit			; Zgoto

	movlw	00
	return

Bit_Frig_Hit:
	btfss	MyBit, 4			; Do we need to swap nybbles?
	goto	Bit_Frig_Swap			;MyBit[4]Zgoto

	movf	MyBit, 0
	andlw	0Fh
	return

Bit_Frig_Swap:
	swapf	MyBit, 0
	andlw	0F0h
	return

SystemSetup:	
	movlw	0
	movwf	Time1
	movwf	Time0
	movwf	DiskNum
	movwf	SlaveBreakFlag

	movlw	1
	movwf	TrackNum

	movlw	0eh				; default Disp mode - user selects
	movwf	DispCtrl

WarmBoot:

	clrf	MyId 				; Set up initial values
	clrf	Display
	clrf	MyBit
	
	bcf	rp0
	clrf	porta
	clrf	portb

	bsf	rp0				; Configure Ports
	movlw	0F7h
	movwf	TRISA				; Port A

	movlw	03
	movwf	TRISB				; Port B - even if not used

	bcf	rp0

	movlw	0Fh				; Set up watchdog timer
	iorwf	option, 1
	clrwdt

	movlw	0D0h
	movwf	MyGroup

	clrf	clock_timer1	; 50usJEgp^C}[
	clrf	clock_timer2	; 50usɃJEgAbv^C}[
	clrf	data_timer1	; 50usJEgp^C}[
	clrf	data_timer2	; 50usɃJEgAbv^C}[ Lԑp
	clrf	data_timer3	; 50usɃJEgAbv^C}[ hԑp
	clrf	anadig
	bcf	porta, DebugBit
	goto	ReceiveBreak

ReceiveBreak:
	btfss	porta_tmp,DataBit
	goto	ReceiveBreak_2			;porta_tmp.DataBit=0ReceiveBreak_2
	goto	BreakCheck1_2			;porta_tmp.DataBit=1BreakCheck1_2

ReceiveBreak_2:
	movf	porta,0
	movwf	porta_tmp

	btfss	porta_tmp, BusOnBit		; BusOnLȂWarmBoot
	goto	WarmBoot

	btfsc	porta_tmp, ClockBit		; ClockBit1ȂReceiveCheck
	goto	ReceiveCheck

	btfsc	porta_tmp, DataBit		; DataBit1ȂBreakCheck1
	goto	BreakCheck1
;DataBit=0
	incf	clock_timer1,1
	incf	data_timer1,1

	movlw	delay50us
	subwf	clock_timer1,0			;clock_timer1-delay5-us
	btfsc	c
	incf	clock_timer2,1			;cy=1:clock_timer1=>delay5_us
	btfsc	c
	clrf	clock_timer1			;cy=1:clock_timer1=>delay5_us

	movlw	delay50us
	subwf	data_timer1,0
	btfsc	c
	incf	data_timer2,1
	btfsc	c
	clrf	data_timer1

	incf	clock_timer2,0
	movlw	254
	btfsc	z
	movwf	clock_timer2

	incf	data_timer2,0
	movlw	254
	btfsc	z
	movwf	data_timer2

	goto	ReceiveBreak_2

BreakCheck1:
	clrf	data_timer1	; 50usJEgp^C}[
	clrf	data_timer3	; 50usɃJEgAbv^C}[ hԑp

BreakCheck1_2:
	movf	porta,0
	movwf	porta_tmp

	btfss	porta_tmp, BusOnBit		; Test for BusOn being high
	goto	WarmBoot

	btfsc	porta_tmp, ClockBit		; ClockBit1ȂReceiveCheck
	goto	ReceiveCheck

	btfss	porta_tmp, DataBit		; DataBit0ȂBreakCheck2
;	goto	BreakCheck2
	goto	BreakCheck3

	incf	clock_timer1,1
	incf	data_timer1,1

	movlw	delay50us
	subwf	clock_timer1,0
	btfsc	c
	incf	clock_timer2,1
	btfsc	c
	clrf	clock_timer1

	movlw	delay50us
	subwf	data_timer1,0
	btfsc	c
	incf	data_timer3,1
	btfsc	c
	clrf	data_timer1

	incf	clock_timer2,0
	movlw	254
	btfsc	z
	movwf	clock_timer2

;	incf	data_timer3,0
;	movlw	254
;	btfsc	z
;	movwf	data_timer3

	movf	data_timer3,0
	sublw	80				;50us*80=4000us
	btfsc	z
	goto	BreakCheck2

	goto	BreakCheck1_2



;1cycle=0.2us

ReceiveCheck:
	movf	clock_timer2,0
	clrf	clock_timer1
	clrf	clock_timer2
	sublw	79				;50us*(79+1)=4000us
	btfss	c
	goto	ReceiveCommand			;clock_timer2-80>0Ȃgoto
	goto	ReceiveBreak

BreakCheck2:

	movf	data_timer2,0
	clrf	data_timer1
	clrf	data_timer2
	clrf	data_timer3
	sublw	120				;50us*120=6000us
	btfsc	c
	goto	ReceiveBreak			;data_timer2-120<=0Ȃgoto

	movf	SlaveBreakFlag,1
	btfsc	z
	goto	ReceiveBreak

	call	BreakStart
	goto	ReceiveBreak

BreakCheck3:
	clrf	data_timer1
	clrf	data_timer2
	clrf	data_timer3
	goto	ReceiveBreak

ReceiveCommand:

	clrf	Checksum			; Clear checksum

	call	ReadByte2			; Get RAD

	movwf	Rad
	addwf	Checksum, 1

	btfsc	z				; Test for a Zero RAD
	goto	ReceiveBreak			; as you're out of sync.

	call	ReadByte			; Get TAD
	movwf	Tad
	addwf	Checksum, 1

	call	ReadByte			; Get CMD1
	movwf	Cmd1
	addwf	Checksum, 1

	call	ReadByte			; Get CMD2
	movwf	Cmd2
	addwf	Checksum, 1

ReceiveParity1:
	call	ReadByte
	movwf	Parity1

	subwf	Checksum, 0			; Test checksum

	btfss	z
	goto	ReceiveBreak			; Checksum was wrong!!

	btfss	Cmd1, 7				; Test for 'Short' commands
	goto	ReceiveEnd
	
RecieveMedium:
	call	ReadByte
	movwf	Data11
	addwf	Checksum, 1

	call	ReadByte
	movwf	Data12
	addwf	Checksum, 1

	call	ReadByte
	movwf	Data13
	addwf	Checksum, 1

	call	ReadByte
	movwf	Data14
	addwf	Checksum, 1

	btfss	Cmd1, 6				; Test for 'Medium' commands
	goto	ReceiveParity2

RecieveLong:
	call	ReadByte
	movwf	Data21
	addwf	Checksum, 1

	call	ReadByte
	movwf	Data22
	addwf	Checksum, 1

	call	ReadByte
	movwf	Data23
	addwf	Checksum, 1

	call	ReadByte
	movwf	Data24
	addwf	Checksum, 1

	call	ReadByte
	movwf	Data25
	addwf	Checksum, 1

ReceiveParity2:
	call	ReadByte
	movwf	Parity2
	subwf	Checksum, 0			; Test checksum

	btfss	z
	goto	ReceiveBreak			; Checksum was wrong!!

ReceiveEnd:
	call	ReadByte
	movwf	EndByte

	btfss	z
	goto	ReceiveBreak			; EndByte was non-zero!!

	movf	Cmd1, 0
	xorlw	01
	btfsc	z
	goto	Cmd1_was_01

	movf	Cmd1, 0
	xorlw	02
	btfsc	z
	goto	Respond_Appoint

	movf	Cmd1, 0
	xorlw	20h
	btfsc	z
	goto	Cmd_Selected

	movf	Cmd1, 0
	xorlw	26h
	btfsc	z
	goto	Cmd_TrackSkip

	movf	Cmd1, 0
	xorlw	27h
	btfsc	z
	goto	Cmd_TrackSkip

	movf	Cmd1, 0
	xorlw	87h
	btfsc	z
	goto	Cmd_PowerOff

	movf	Cmd1, 0
	xorlw	0F0h
	btfsc	z
	goto	Cmd_Deselected

	goto	ReceiveBreak

;--------

Cmd1_was_01:
	movf	Cmd2, 0
	btfsc	z				; Check for 'Init'
	goto	WarmBoot

	movf	Cmd2, 0
	xorlw	02				; Check for 'Anyone'
	btfsc	z
	goto	Respond_Anyone

	movf	Cmd2, 0
	xorlw	11h				; Check for 'Alive'
	btfsc	z
	goto	Respond_Hello

	movf	Cmd2, 0
	xorlw	12h				; Check for 'Ping'
	btfsc	z
	goto	Respond_Ping

	movf	Cmd2, 0
	xorlw	13h				; Check for 'Slave Poll'
	btfsc	z
	goto	Respond_SlavePoll

	movf	Cmd2, 0
	xorlw	15h				; Check for 'Master Poll'
	btfsc	z
	goto	Respond_MasterPoll

	goto	ReceiveBreak

;--------

Cmd_Selected:
	movf	MyId, 0				; ensure it's the right ID
	subwf	Rad, 0
	btfss	z
	goto	ReceiveBreak

Cmd_Selected2:

	movlw	1				; Restart the display sequence
	movwf	Display

	call	IssueSlaveBreak			; cause display to 
						; appear quickly

	goto	ReceiveBreak


Cmd_TrackSkip:
	movf	MyId, 0				; ensure it's the right ID
	subwf	Rad, 0
	btfss	z
	goto	ReceiveBreak

	movf	anadig,0
	xorlw	255
	movwf	anadig

	movlw	8				; Restart the display sequence
	btfsc	z
	movlw	10
	
	movwf	Display

	call	IssueSlaveBreak			; cause display to 
						; appear quickly

	goto	ReceiveBreak



Cmd_PowerOff:
	movf	Cmd2, 0
	xorlw	6Bh
	btfss	z
	goto	ReceiveBreak


	clrf	Display 			; Immediately stop attempting 
						; to display stuff

	goto	ReceiveBreak

Cmd_Deselected:
	movf	Cmd2, 0				; ensure it's the right ID
	subwf	MyId, 0
	btfsc	z
	goto	Cmd_Selected2			; actually it's me selected

	clrf	anadig
	bcf	porta, DebugBit

	clrf	Display 			; Immediately stop attempting 
						; to display stuff

	goto	ReceiveBreak

;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
; Various responses to the commands
; These are clocked out by the master when it is ready

Respond_Anyone:

	movf	MyId, 1				; Test if we've got an ID
	btfss	z
	goto	ReceiveBreak			; we don't need another one

	clrf	Checksum 			; Clear checksum

	movlw	10h				; 'I'm a .....'
	
	call	SendByte

	movf	MyGroup, 0
	call	SendByte

Respond_Anyone2:
	movlw	Anyone_0
	call	SendByte

	movlw	Anyone_1
	call	SendByte

	movf	Checksum, 0			; Save Current Checksum
	movwf	Count2

	movf	Checksum, 0			; Send Checksum
	call	SendByte

	movf	Count2, 0			; Restore Checksum
	movwf	Checksum
	
	movlw	Anyone_2
	call	SendByte

	movlw	Anyone_3
	call	SendByte

	movlw	Anyone_4
	call	SendByte

	movlw	Anyone_5
	call	SendByte
	
Respond_End:
	movf	Checksum, 0			; Send Checksum
	call	SendByte
	
	movlw	00
	call	SendByte
	
	goto	ReceiveBreak			; Done, wait for next command

;--------

Respond_Appoint:
	movf	Rad, 0				; Store allocated ID
	andlw	0f0h
	xorlw	0d0h
	btfss	z
	goto	ReceiveBreak			;RAD/=0dxh

Respond_Appoint2:
	movf	Rad, 0				; Store allocated ID
	movwf	MyId

	movf	Cmd2, 0				; Store bit position 
	movwf	MyBit				; (for SlavePoll response)

Respond_App2:
	clrf	Checksum 			; Clear checksum

	movlw	10h				; 'OK I'm ID=X'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	goto	Respond_Anyone2			; same as 'Anyone'

;--------

Respond_Hello:
	movf	MyId, 1				; Test for ID
	btfss	z
	goto	ReceiveBreak			; keep quiet if we have...

	clrf	Checksum 			; Clear checksum

	movlw	10h				; 'You've missed me!!'
	call	SendByte

	movlw	18h
	call	SendByte

	movlw	04
	call	SendByte

	movlw	00
	call	SendByte

	goto	Respond_End

;--------

Respond_Ping:
	movf	MyId, 0				; Check it's the right ID
	subwf	Rad, 0
	btfss	z
	goto	ReceiveBreak			; Done, wait for next command

	clrwdt					; Reset the watchdog

	clrf	Checksum 			; Clear checksum

	movlw	10h				; 'I'm playing'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	00
	call	SendByte

	movlw	80h				; 'Idle'
	
	movf	Display, 1			; test if we're active
	btfss	z
	movlw	00				; 'Playing'

	call	SendByte

	movf	Checksum, 0			; Send Checksum
	call	SendByte
	
	movlw	00
	call	SendByte

	movf	Display, 0
	andlw	7fh				; strip off high nyble
	xorlw	00				; Test to see if we've got 
						; something to display
	btfss	z
	call	IssueSlaveBreak
	
	goto	ReceiveBreak			; wait for next command

;******************************************************************************
; Response to Master Poll Command

Respond_MasterPoll:
	movf	Display, 0
	xorlw	00				; Test if we're active
	btfsc	z
	goto	ReceiveBreak			; wait for next command
	
	clrf	Checksum 			; Clear checksum

	movlw	10h				; 'Something has changed!'
	call	SendByte

	movlw	18h				; is to a broadcast address
	call	SendByte

	movlw	82h
	call	SendByte

	movlw	00				; MyBit is 0x0? or 0x1?
	call	Bit_Frig
	call	SendByte

	movf	Checksum, 0			; Save Current Checksum
	movwf	Count2

	movf	Checksum, 0			; Send Checksum
	call	SendByte

	movf	Count2, 0			; Restore Checksum
	movwf	Checksum
	
	movlw	20h				; MyBit is 0x2? or 0x3?
	call	Bit_Frig
	call	SendByte

	movlw	40h				; MyBit is 0x4? or 0x5?
	call	Bit_Frig
	call	SendByte

	movlw	60h				; MyBit is 0x6? or 0x7?
	call	Bit_Frig
	call	SendByte

	movlw	80h				; MyBit is 0x8? or 0x9?
	call	Bit_Frig
	call	SendByte
	
	goto	Respond_End			; to do checksum and error byte

;******************************************************************************

Respond_SlavePoll:
	movf	MyId, 0				; Check it's the right ID
	subwf	Rad, 0
	btfss	z
	goto	ReceiveBreak			; Done, wait for next command

	clrf	Checksum 			; Clear checksum

	incf	Display, 1			; Increment Display Count,
						; remember you're "+1"

	movf	Display, 0
	xorlw	02				; Check if 1st repsonse		//c0 40
	btfsc	z
	goto	Respond_SlavePoll_1		; Zgoto

	movf	Display, 0
	xorlw	03				; Check if 2nd repsonse		//c0 00
	btfsc	z
	goto	Respond_SlavePoll_2

	movf	Display, 0
	xorlw	04				; Check if 3rd repsonse		//90 60
	btfsc	z
	goto	Respond_SlavePoll_3

	movf	Display, 0
	xorlw	05				; Check if 4th repsonse		//c9
	btfsc	z
	goto	Respond_SlavePoll_4

	movf	Display, 0
	xorlw	06				; Check if 5th repsonse		//c9
	btfsc	z
	goto	Respond_SlavePoll_5

	movf	Display, 0
	xorlw	07				; Check if 6th repsonse		//cd
	btfsc	z
	goto	Respond_SlavePoll_6

	movf	Display, 0
	xorlw	08				; Check if 7th repsonse		//cd
	btfsc	z
	goto	Respond_SlavePoll_7


	movf	Display, 0
	xorlw	9				; Check if 1th repsonse		//cd
	btfsc	z
	goto	Respond_SlavePoll_8

	movf	Display, 0
	xorlw	10				; Check if 2th repsonse		//cd
	btfsc	z
	goto	Respond_SlavePoll_9

	movf	Display, 0
	xorlw	11				; Check if 1th repsonse		//cd
	btfsc	z
	goto	Respond_SlavePoll_4

	movf	Display, 0
	xorlw	12				; Check if 2th repsonse		//cd
	btfsc	z
	goto	Respond_SlavePoll_5b



	goto	ReceiveBreak			; should NEVER get here!!

;--------

Respond_SlavePoll_1:
	movlw	77h				; 'Seeking CD'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0c0h
	call	SendByte

	movlw	40h
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	00
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00
	call	SendByte
	
	movlw	00
	call	SendByte
	
	movf	TrackNum, 0			; Track Number
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00
	call	SendByte

	swapf	DiskNum, 0			; Disk Number + disp code
	iorlw	01
	call	SendByte
	
	goto	Slave_Respond_End

;--------

Respond_SlavePoll_2:
	movlw	70h				; 'Seeking to Track'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0c0h
	call	SendByte

	movlw	00
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	00
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00
	call	SendByte
	
	movlw	00
	call	SendByte
	
	movf	TrackNum, 0			; Track Number
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00
	call	SendByte

	swapf	DiskNum, 0			; Disk Number + disp code
	iorlw	0dh
	call	SendByte
	
	goto	Slave_Respond_End

;--------
	
Respond_SlavePoll_3:
	movlw	70h				; "CD d, Track t, mm:ss"
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	90h
	call	SendByte

	movlw	50h
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movf	TrackNum, 0			; Track Number
	call	SendByte

	movf	Time1, 0			; Track Timer
	call	SendByte

	movf	Time0, 0			; Track Timer
	call	SendByte

	swapf	DiskNum, 0			; Disk Number + Disp code
	iorwf	DispCtrl, 0
	call	SendByte

	goto	Slave_Respond_End

;----

Respond_SlavePoll_4:
	clrf	anadig
	bcf	porta, DebugBit
	movlw	70h				; 'Track name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0C9h
	call	SendByte

	movlw	Track0
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	Track1
	call	SendByte

	movlw	Track2
	call	SendByte

	movlw	Track3
	call	SendByte

	movlw	Track4
	call	SendByte
	
	movlw	Track5
	call	SendByte

	movlw	Track6
	call	SendByte

	movlw	Track7
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00				; field 0
	iorwf	DispCtrl, 0
	call	SendByte

	goto	Slave_Respond_End

;--------

Respond_SlavePoll_5:
	movlw	70h				; 'Track name, part2'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0C9h
	call	SendByte

	movlw	Track8
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	Track9
	call	SendByte

	movlw	TrackA
	call	SendByte

	movlw	TrackB
	call	SendByte

	movlw	TrackC
	call	SendByte
	
	movlw	TrackD
	call	SendByte

	movlw	TrackE
	call	SendByte

	movlw	TrackF
	call	SendByte

	movlw	00
	call	SendByte

	movlw	10h				; field 1
	iorwf	DispCtrl, 0
	call	SendByte

	goto	Respond_End


Respond_SlavePoll_5b:
	movlw	70h				; 'Track name, part2'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0C9h
	call	SendByte

	movlw	Track8
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	Track9
	call	SendByte

	movlw	TrackA
	call	SendByte

	movlw	TrackB
	call	SendByte

	movlw	TrackC
	call	SendByte
	
	movlw	TrackD
	call	SendByte

	movlw	TrackE
	call	SendByte

	movlw	TrackF
	call	SendByte

	movlw	00
	call	SendByte

	movlw	10h				; field 1
	iorwf	DispCtrl, 0
	call	SendByte

	goto	Respond_SlavePoll_Done

;--------

Respond_SlavePoll_6:
	movlw	70h				; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0CDh
	call	SendByte

	movlw	Disk0
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	Disk1
	call	SendByte

	movlw	Disk2
	call	SendByte

	movlw	Disk3
	call	SendByte

	movlw	Disk4
	call	SendByte
	
	movlw	Disk5
	call	SendByte

	movlw	Disk6
	call	SendByte

	movlw	Disk7
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00				; field 0
	iorwf	DispCtrl, 0
	call	SendByte

	goto	Slave_Respond_End

;--------

Respond_SlavePoll_7:
	movlw	70h				; 'CD name, part 2'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0CDh
	call	SendByte

	movlw	Disk8
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	Disk9
	call	SendByte

	movlw	DiskA
	call	SendByte

	movlw	DiskB
	call	SendByte

	movlw	DiskC
	call	SendByte
	
	movlw	DiskD
	call	SendByte

	movlw	DiskE
	call	SendByte

	movlw	DiskF
	call	SendByte

	movlw	00
	call	SendByte

	movlw	10h				; field 0
	iorwf	DispCtrl, 0
	call	SendByte

Respond_SlavePoll_Done:
	movlw	80h				; to stop slave polling
	movwf	Display

	goto	Respond_End

;----
Respond_SlavePoll_8:

	movlw	255
	movwf	anadig
	bsf	porta, DebugBit

	movlw	70h				; 'Track name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0C9h
	call	SendByte

	movlw	Trackd_0
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	Trackd_1
	call	SendByte

	movlw	Trackd_2
	call	SendByte

	movlw	Trackd_3
	call	SendByte

	movlw	Trackd_4
	call	SendByte
	
	movlw	Trackd_5
	call	SendByte

	movlw	Trackd_6
	call	SendByte

	movlw	Trackd_7
	call	SendByte

	movlw	00
	call	SendByte

	movlw	00				; field 0
	iorwf	DispCtrl, 0
	call	SendByte

	goto	Slave_Respond_End

;--------

Respond_SlavePoll_9:
	movlw	70h				; 'Track name, part2'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0C9h
	call	SendByte

	movlw	Trackd_8
	call	SendByte

	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum
	
	movlw	Trackd_9
	call	SendByte

	movlw	Trackd_A
	call	SendByte

	movlw	Trackd_B
	call	SendByte

	movlw	Trackd_C
	call	SendByte
	
	movlw	Trackd_D
	call	SendByte

	movlw	Trackd_E
	call	SendByte

	movlw	Trackd_F
	call	SendByte

	movlw	00
	call	SendByte

	movlw	10h				; field 1
	iorwf	DispCtrl, 0
	call	SendByte

	goto	Respond_SlavePoll_Done




Slave_Respond_End:
	movf	Checksum, 0			; Send Checksum
	call	SendByte
	
	movlw	00
	call	SendByte

	call	IssueSlaveBreak			; cause next_display to i
						; appear quickly

	goto	ReceiveBreak			; Done, wait for next command


;******************************************************************************

